base/urls.py
from django.urls import path
from . import views

app_name = 'base'

urlpatterns = [
    path('', views.index, name='base'),
    # path('/masker', views.masker, name='masker'),
    # path('/sanitizer', views.sanitizer, name='sanitizer'),
    # path('/faceshield', views.faceshield, name='faceshield'),
    path('/add', views.tambahin, name='add'),
    path('/reduce', views.kurangin, name='reduce'),
    path('login/', views.login_tk2, name='login'),
    path('logout/', views.logout_tk2, name='logout'),
    path('signup/', views.signup, name='signup'),

]

feedback/urls.py
from django.urls import path
from . import views

app_name = 'feedback'
urlpatterns = [
    path('', views.index, name='index'),
    path('saveFeedback/', views.saveFeedback, name='saveFeedback'),
    path('allFeedback/', views.allFeedback, name='allFeedback'),

]

pandenemy2/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('base.urls')),
    path('', include('postingan.urls')),
    path('semangatpage/', include('semangatpage.urls')),
    path('feedback/', include('feedback.urls')),
    path('profile/', include('profilepage.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

semangatpage/urls.py
from django.urls import include, path, re_path
from . import views

app_name = 'semangatpage'

urlpatterns = [
    path('', views.semangat, name='semangat'),
    path('addsemangat/', views.add_semangat, name='addsemangat'),
    path('findauthor/', views.find_author, name='findauthor'),
    path('findauthor/semangatDB/',views.datajson, name='datajson'),
]

base/models.py
from django.db import models
from django.contrib.auth.models import User


class PoolingBarang (models.Model):
    # Models barang
    # DIGANTI: biar tiap user punya daftar barangnya sendiri
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    barang = models.CharField('Barang', max_length=20, null=True)
    stok = models.IntegerField('Like', default=0, null=True)


class BarangKepunyaan (models.Model):
    # Models yang diisi daftar barang yang dipunyain user
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    daftarBarang = models.ManyToManyField(PoolingBarang)


# Create your models here.

base/forms.py
from django import forms

class loginForm(forms.Form):
    username = forms.CharField(widget=forms.TextInput(attrs={'class': 'form-control', 'type' : 'text', 'placeholder' : 'Username' , 'required' : True,}))
    password = forms.CharField(widget=forms.TextInput(attrs={'class' : 'form-control', 'type' : 'password', 'placeholder' : 'Password' , 'required' : True,}))

class registerForm(forms.Form):
    username = forms.CharField(widget=forms.TextInput(attrs={'class': 'form-control', 'type' : 'text', 'placeholder' : 'Username' , 'required' : True,}))
    email = forms.CharField(widget=forms.TextInput(attrs={'class': 'form-control', 'type' : 'text', 'placeholder' : 'Email' , 'required' : True,}))
    password = forms.CharField(widget=forms.TextInput(attrs={'class' : 'form-control', 'type' : 'password', 'placeholder' : 'Password' , 'required' : True,}))

base/views.py
from django.shortcuts import render, redirect
from .models import PoolingBarang, BarangKepunyaan
from .forms import loginForm, registerForm
from django.contrib.auth import authenticate, login, logout
from django.http import JsonResponse
from django.contrib.auth.models import User
from django.contrib.auth.decorators import login_required


def index(request):
    if request.user.is_authenticated:
        # return tuple 
        listBarang, created = BarangKepunyaan.objects.get_or_create(user=request.user)
        if created == True:
            masker = PoolingBarang.objects.create(
                user=request.user,
                barang="Masker",
                stok=0
            )
            masker.save()
            sanitizer = PoolingBarang.objects.create(
                user=request.user,
                barang="Sanitizer",
                stok=0
            )
            sanitizer.save()
            faceshield = PoolingBarang.objects.create(
                user=request.user,
                barang="Face Shield",
                stok=0
            )
            faceshield.save()
            listBarang.daftarBarang.add(masker, sanitizer, faceshield)
            listBarang.save() 
            # To create and save an object 

        barang = listBarang.daftarBarang.all()
        map = {
            'barang': barang,
        }
        return render(request, 'base/index.html', map)
    return render(request, 'base/index.html')


def kurangin(request):
    namaBarang = request.POST.get('barang', None)
    # listBarang = BarangKepunyaan.objects.get(user=request.user)
    barang = PoolingBarang.objects.get(user=request.user, barang=namaBarang)
    if barang.stok > 0:
        barang.stok -= 1
        barang.save()
    else:
        response = JsonResponse(
            {"error": "Ayo beli persediaan barang jangan sampai habis"})
        response.status_code = 403
        return response
    return redirect('/')


def tambahin(request):
    namaBarang = request.POST.get('barang', None)
    # listBarang = BarangKepunyaan.objects.get(user=request.user)
    barang = PoolingBarang.objects.get(user=request.user, barang=namaBarang)
    barang.stok += 1
    # print(barang.stok)
    barang.save()
    return redirect('/')


def login_tk2(request):
    if request.method == "POST":
        form = loginForm(request.POST)
        if form.is_valid():
            input_username = form.cleaned_data['username']
            input_password = form.cleaned_data['password']
            user = authenticate(
                request, username=input_username, password=input_password)
            if user is not None:
                login(request, user)
                return redirect('/')
            else:
                return redirect('/signup/')
    else:
        form = loginForm()
        response = {'form': form}
        return render(request, 'base/login.html', response)


def logout_tk2(request):
    logout(request)
    return redirect('/')


def signup(request):
    if request.method == "POST":
        form = registerForm(request.POST)
        if form.is_valid():
            input_username = form.cleaned_data.get("username")
            input_email = form.cleaned_data.get("email")
            input_password = form.cleaned_data.get("password")
            try:
                user = User.objects.get(username=input_username)
                return redirect('/signup/')
            except User.DoesNotExist:
                user = User.objects.create_user(
                    input_username, input_email, input_password)
                return redirect('/login/')
    else:
        form = registerForm()
        response = {'form': form}
        return render(request, 'base/signup.html', response)

base/templates/base/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <script src="https://code.jquery.com/jquery-3.4.1.js"   integrity="sha256-WpOohJOqMqqyKL9FccASB9O0KwACQJpFTUBLTYOVvVU="   crossorigin="anonymous"></script>
    <link
      rel="stylesheet"
      href="{% static 'bootstrap-4.5.3-dist\css\bootstrap.css' %}"
    />
    {% block link %} {% endblock link %}
    <link rel="stylesheet" href="{% static 'style.css' %}" />

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>

    <script src="{% static 'bootstrap-4.5.3-dist\js\bootstrap.js' %}"></script>

    
    {% if title %}
    <title>{{title}}</title>

    {% else %}
    <title>Pandenemy</title>
    {% endif %}
</head>
<body>

    <nav class="navbar sticky-top navbar-expand-sm bg-dark navbar-dark" style="padding-left: 3%;">
        <a class="navbar-brand" href="/">
            <img src="{% static 'images/logo.svg' %}" style="width: 35px;">
        </a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarNav">
            {% if user.is_authenticated %}
            <ul class="nav navbar-nav ml-auto mt-2 mt-lg-0" style="padding-right: 20px;">
                <li class="nav-item" style="margin: 10px;">
                    <a href="#">Welcome, {{ user.get_username }}</a>
                </li>
                <li class="nav-item active" style="margin: 10px;">
                    <a href="/">Home</a>
                </li>
                <li class="nav-item" style="margin: 10px;">
                    <a href="/#fitur">Fitur</a>
                </li>
                <li class="nav-item" style="margin: 10px;">
                    <a href="/profile">Profile</a>
                </li>
                <li class="nav-item" style="margin: 10px;">
                    <a href="{% url 'base:logout' %}">Logout</a>
                </li>
            </ul>
            {% else %}
            <ul class="nav navbar-nav ml-auto mt-2 mt-lg-0" style="padding-right: 20px;">
                <li class="nav-item active" style="margin: 10px;">
                    <a href="/">Home</a>
                </li>
                <li class="nav-item" style="margin: 10px;">
                    <a href="/#fitur">Fitur</a>
                </li>
                <li class="nav-item" style="margin: 10px;">
                    <a href="/profile">Profile</a>
                </li>
                <li class="nav-item" style="margin: 10px;">
                    <a href="{% url 'base:signup' %}">Sign Up</a>
                </li>
                <li class="nav-item" style="margin: 10px;">
                    <a href= "{% url 'base:login' %}?next={{request.path}}">Login</a>
                </li>
            </ul>
            {% endif %}
        </div>
    </nav>
    {% block content %} {% endblock content %}

    <!-- <script
      src="https://code.jquery.com/jquery-3.5.1.slim.min.js"
      integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj"
      crossorigin="anonymous"
    ></script> -->
    <script
      src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"
      integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN"
      crossorigin="anonymous"
    ></script>
    <script
      src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"
      integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV"
      crossorigin="anonymous"
    ></script>

    {% block script %} {% endblock script %}
  </body>
</html>

base/templates/base/index.html
{% extends "base/base.html" %}
{% load static %}

{% block content %}
<script src="{% static 'barang.js' %}"></script>

<div class="wrapper" style="min-height: 100vh;">
    
    <div class="row">
        <div class="col-md-7">
            <div class="login d-flex align-items-center py-5">
                <div class="container">
                        <div class="mx-5">
                            <h1 class="judul">Pand<span class="judul2">enemy</span></h1>
                            <br>
                            <p class="text-justify" style="font-size: 15px; line-height: 1.8;">
                                Pandemi Covid-19 saat ini sudah menjamur dimana-mana.
                                Penanganan yang sulit membuat semakin banyak daerah menjadi kerepotan untuk menanggulangi
                                masalah ini. Banyak dampak yang ditimbulkan dari pandemi ini, 
                                tidak lain seperti perekonomian, kesehatan, bahkan studi. Sebagai mahasiswa, proses 
                                pembelajaran jarak jauh menjadi sebuah tantangan juga hambatan. Untuk itu, pandemi ini 
                                adalah enemy (musuh) yang harus kita siasati bersama. Melalui website ini kami mencoba untuk 
                                membantu Anda untuk dapat melewati masa sulit ini dengan beberapa fitur yang memanjakan. 
                                Selamat mencoba! 
                            </p>
                        </div>
                </div>
            </div>
        </div>
        <div class="col-md-5 d-none d-md-flex">
            <section class="section">
                <img src="{% static 'images/bgbase.svg' %}" class="index-bg"/>
            </section>
        </div>
    </div>
</div>

<div class="containter-fluid wrapper" style="min-height: 100vh;">
    <div class="col-md-12 pt-2" style="text-align: right; padding-right:30%">
        <h1 class="judul">Kabar<span class="judul2">?</span></h1>
    </div>
    <div class="row">
        <div class="col-md-6">
            <div class="login d-flex align-items-center py-5">
                <div class="mx-5">
                    <p class="text-justify">
                        Jumlah pasien/kasus aktif Covid-19 di Depok kini mencapai 1.413 orang hingga data diperbarui kemarin, Senin (19/10/2020). 
                        Angka ini jauh di atas puncak gelombang pertama pada Mei 2020 lalu, dengan 383 kasus aktif. Dari data yang sama diketahui, 
                        pasien Covid-19 di Depok saat ini paling banyak merupakan warga Kecamatan Pancoran Mas (188 kasus) dan Beji (180 kasus). 
                        Penambahan kasus aktif terbanyak sepekan ini ada di Kecamatan Limo (44 kasus).
                    </p>
                </div>
            </div>
        </div>
        <div class="col-md-6 col-xs-1 text-center" >
            <section class="no-touch col-xs-1 text-cente gambar" >
                <div class="box">
                    <div class="boxInner">
                        <img src="{% static 'images/beritalimo.jpg' %}" />
                        <div class="titleBox">Kecamatan Limo Catat Tambahan Pasien Covid Terbesar</div>
                    </div>
                </div>
            </section>
        </div>
    </div>
</div>


<div id="fitur" class="col-md-12 pt-2" style="text-align: center">
    <h1 class="judul">Layanan<span class="judul2">.</span></h1>
</div>

<div class="col-md-12">
    <div class="row">
        <div class="col-md-2"></div>
        <div class="col-md-4 col-sm-12 d-flex align-items-center justify-content-center text-center">
            <a href="{% url 'semangatpage:semangat' %}" style="color: black;">
                <div class="card mb-3 animasi-card" style="max-width: 350px;margin:40px">
                    <div class="row no-gutters">
                        <div class="col-md-4">
                        <img src="{% static 'images/berisemangat.png' %}" class="card-img" alt="..." style="padding: 5%;">
                        </div>
                        <div class="col-md-8">
                        <div class="card-body" style="padding:0.25rem">
                            <p class="card-title">Beri Semangat</p>
                        </div>
                        </div>
                    </div>
                </div>
            </a>
        </div>
        <div class="col-md-4 col-sm-12 d-flex align-items-center justify-content-center text-center">
            <a style="color: black;" href="">
                <div class="card mb-3 animasi-card" style="max-width: 350px;margin:40px">
                    <div class="row no-gutters">
                        <div class="col-md-4">
                        <img src="{% static 'images/aturjadwal.jpg' %}" class="card-img" alt="..." style="padding: 5%;">
                        </div>
                        <div class="col-md-8">
                        <div class="card-body" style="padding:0.25rem">
                            <p class="card-title">Atur Jadwal</p>
                        </div>
                        </div>
                    </div>
                </div>
            </a>
        </div>
        <div class="col-md-2"></div>
    </div>
</div>

<div class="col-md-12">
    <div class="row">
        <div class="col-md-2"></div>
        <div class="col-md-4 col-sm-12 d-flex align-items-center justify-content-center text-center">
            <a style="color: black;" href="{% url 'feedback:index' %}">
                <div class="card mb-3 animasi-card" style="max-width: 350px;margin:40px">
                    <div class="row no-gutters">
                        <div class="col-md-4">
                        <img src="{% static 'images/feedback.png' %}" class="card-img" alt="..." style="padding: 5%;">
                        </div>
                        <div class="col-md-8">
                        <div class="card-body" style="padding:0.25rem">
                            <p class="card-title">Feedback</p>
                        </div>
                        </div>
                    </div>
                </div>
            </a>
        </div>
        <div class="col-md-4 col-sm-12 d-flex align-items-center justify-content-center text-center" ">
            <a style="color: black;" href="/postingan/">
                <div class="card mb-3 animasi-card" style="max-width: 350px;margin:40px;">
                    <div class="row no-gutters">
                        <div class="col-md-4">
                        <img src="{% static 'images/postingmomen.png' %}" class="card-img" alt="..." style="padding: 5%;">
                        </div>
                        <div class="col-md-8">
                        <div class="card-body" style="padding:0.25rem">
                            <p class="card-title">Posting Momen</p>
                        </div>
                        </div>
                    </div>
                </div>
            </a>
        </div>
        <div class="col-md-2"></div>
    </div>
</div>

<div class="hindari" style="margin-top:100px">
    <div class="container" style="min-height: 100vh;">
        <div class="row">
            <div class="col-md-12 pt-5" style="text-align: center;">
                <h1 class="judul3">Hindari<span class="judul2">!</span></h1>
            </div>
            <div class="col-md-12">
                <div class="main-timeline"  style="margin-top: 60px;">
                    <div class="timeline"style="margin-top: 5%;">
                        <span class="icon"><i>1</i></span>
                        <div class="timeline-content">
                            <div class="content-inner">
                                <h3 class="title">Bertemu dengan orang banyak</h3>
                            </div>
                        </div>
                    </div>
                    <div class="timeline" style="margin-top: 10%;">
                        <span class="icon"><i>2</i></span>
                        <div class="timeline-content">
                            <div class="content-inner">
                                <h3 class="title">Tidak memakai masker saat keluar rumah</h3>
                            </div>
                        </div>
                    </div>
                    <div class="timeline"  style="margin-top: 2%;">
                        <span class="icon"><i>3</i></span>
                        <div class="timeline-content">
                            <div class="content-inner">
                                <h3 class="title">Tidak mencuci tangan dengan rutin setiap melakukan aktivitas
                                </h3>
                            </div>
                        </div>
                    </div>
                    <div class="timeline" style="margin-top: 8%;">
                        <span class="icon"><i>4</i></span>
                        <div class="timeline-content">
                            <div class="content-inner">
                                <h3 class="title">Berpergian tanpa tujuan yang penting</h3>
                            </div>
                        </div>
                    </div>
                    <div class="timeline"  style="margin-top: 2%; margin-bottom:75px">
                        <span class="icon"><i>5</i></span>
                        <div class="timeline-content">
                            <div class="content-inner">
                                <h3 class="title">Istirahat yang tidak teratur
                                </h3>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<div class="containter-fluid " style="min-height: 140vh;">
    <div class="col-md-12 pt-2" style="text-align: center; margin-top:50px">
        <h1 class="judul">Stock<span class="judul2">.</span></h1>
        <p>Pengingat stock dari barang penting saat pandemi yang kamu punya!</p>
    </div>
    <div class="row pt-5" style="margin-bottom: 40px;" >
        <!-- <div> -->
        {% if request.user.is_authenticated %}
        {% for x in barang %}

        <!-- Membuat row sesuai jumlah barang -->
            <div class="col-md-4  pb-5 text-center pooling" >
                <p>{{ x.barang }}</p>
                    {% if x.barang == "Masker" %}
                    <img class="barangbg" src="{% static 'images/masker.png' %}" style="width:250px; height: 230px;">
                    {% elif x.barang == "Sanitizer" %}
                    <img class="barangbg" src="{% static 'images/sinitizer.png' %}" style="width:250px; height: 230px;">
                    {% elif x.barang == "Face Shield" %}
                    <img class="barangbg" src="{% static 'images/faceshield.png' %}" style="width:250px; height: 230px;">
                    {% endif %}

                    <div id="stok">
                        <p  style="display: inline;" id="stok-barang">{{ x.stok }}</p>
                        <p  style="display: inline;"> tersedia</p>
                    </div>
                        
                    <br>
                    <div id="{{x.barang}}" class="row align-items-center justify-content-center">
                        <form  class="kurang" action="{% url 'base:reduce' %}" method="post">
                            {% csrf_token %}
                            <input type="submit" value="Kurang" class="btn btn-danger " role="button" style="margin-right: 20px;"></input>
                            
                        </form>
                        
                        <form  class="tambah" action="{% url 'base:add' %}" method="post">
                            {% csrf_token %}
                            <input type="submit" value="Tambah" class="btn btn-success" role="button"></input>
                            
                        </form>
                    </div>

            </div>


        {%  if forloop.counter|divisibleby:3 or forloop.last %}
            </div><!-- row closing --><hr>
        {%  endif %}
        {% endfor %}

        <!-- kalau user belum login -->
        {% else %}
        
        <div class="col-md-4  pb-5 text-center" >
            <p>Masker</p>
            <img src="{% static 'images/masker.png' %}" style="width:250px; height: 230px;">
            <br>
            <a href="{% url 'base:login' %}">
                <button class="btn btn-secondary" role="button" style="margin-top:20px">Login</button>
            </a>
        </div>
        <div class="col-md-4  pb-5 text-center" >
            <p>Sanitizer</p>
            <img src="{% static 'images/sinitizer.png' %}" style="width:250px; height: 230px;">
            <br>
            <a href="{% url 'base:login' %}">
                <button class="btn btn-secondary" role="button" style="margin-top:20px">Login</button>
            </a>
        </div>
        <div class="col-md-4  pb-5 text-center" >
            <p>Face Shield</p>
            <img src="{% static 'images/faceshield.png' %}" style="width:250px; height: 230px;">
            <br>
            <a href="{% url 'base:login' %}">
                <button class="btn btn-secondary" role="button" style="margin-top:20px">Login</button>
            </a>
            
        </div>
        {% endif %}
        </div>
        </div>
        
 
    </div>
    
    <div class="footer">
        <div id="button" style="margin-top: 10px;"></div>
            <div id="container" style="max-height: 20vh;">
            <div id="cont">
            <div class="footer_center">
                <h3>Hotline<span style="padding-left: 20px;padding-right: 8px;"><img src="{% static 'images/phone.svg' %}" style="width: 25px;"/></span>  119</h3>
            </div>
            </div>
        </div>
    <!-- </div> -->
</div>





{% endblock content %}

base/templates/base/login.html
{% extends "base/base.html" %}
{% load static %}

{% block link %}
<link rel="stylesheet" href="{% static 'loginstyle.css' %}">
{% endblock link %}

{% block content %}
<div class="main">
    <div class="container-fluid" style="min-height: 90vh;">
        <div class="row mt-4"> 
            <form action="" method="POST" class="col-lg-4 col-md-12 ">
                <p>Masuk ke dalam akun mu!</p>
                {% csrf_token %}
                <div class="form-group">
                    {{ form.username }}
                </div>
                <div class="form-group">
                    {{ form.password }}
                </div>
                <button type="submit" class="btn btn-rose mt-3 mb-4" id="login">login</button>
                <br>
                <small class="text-muted" style="text-align: center; ">
                    Belum punya account? <a href="{% url 'base:signup' %}" style="color: dodgerblue;"> Sign Up</a>
                </small>
            </form>
            
            <div class="col-lg-8 align-content-center d-none d-lg-flex" >
                <h1 style="padding-left: 50px;">Welcome!</h1>
                
            </div>
           
        
        </div>
    </div>
</div>
<div style="text-align: center; ">
    <p id="pesan">" Sebuah platform yang akan membantu mu melewati Pandenemy "</p>
</div>



<!-- <br>
<div class="card col-6 mx-auto">
    <form method="POST">
        {% csrf_token %}
        <br> 
        {{ form.username }}
        <br>
        {{ form.password }}
        <br>
        <button type="submit" class="btn btn-primary">Login</button>
    </form>
</div> -->
{% endblock content %}

base/templates/base/signup.html
{% extends "base/base.html" %}
{% load static %}

{% block link %}
<link rel="stylesheet" href="{% static 'loginstyle.css' %}">
{% endblock link %}

{% block content %}

<div class="main">
    <div class="container">
        <div class="row mt-4"> 
            <form action="" method="POST" class="col-lg-4 col-md-12 ">
                <p>Masuk ke dalam akun mu!</p>
                {% csrf_token %}
                <div class="form-group">
                    {{ form.username }}
                </div>
                <div class="form-group">
                    {{ form.email }}
                </div>
                <div class="form-group">
                    {{ form.password }}
                </div>
                <button type="submit" class="btn btn-rose mt-3 mb-4" id="login">Sign Up</button>
            </form>
            <div class="col-lg-8 align-content-center d-none d-lg-flex" >
                <h1 style="padding-left: 50px;">Welcome!</h1>
                
            </div>
        </div>
    </div>
</div>
<div style="text-align: center; ">
    <p id="pesan">" Sebuah platform yang akan membantu mu melewati Pandenemy "</p>
</div>

{% endblock content %}